{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2003-2012      Martin Wodrich, http://www.martinwodrich.de  }
{ (c) 2008-2012      FreeXP, http://www.freexp.de                 }
{                                                                 }
{ Dieser Quelltext ist Freeware.                                  }
{                                                                 }
{ Die allgemeinen Nutzungsbedingungen fuer diesen Quelltext       }
{ finden Sie in der Datei TOUCH.TXT oder auf                      }
{ http://www.martinwodrich.de/Software/Touch/nutzung.htm          }
{ --------------------------------------------------------------- }
{ $Id: touch.inc,v 1.17 2012-07-22 14:33:54 mw Exp $ }

{ Erstmal einiges definieren }

{ Nur GPL-Module benutzen? }
{.DEFINE GPLONLY}

{ Cryptolib fr Win64 nicht benutzen? - Cryptolib ist nur als PurePascal Win64 fhig }
{$IFDEF Win64}
   {$DEFINE NOCRYPT}
{$ENDIF}

{ FreeXP-Setting}
{$DEFINE freexp}

{ Borland Pascal 7.0 oder 8.0 }
{$IFDEF VER70 }
  {$DEFINE BP}
  {$IFNDEF WINDOWS}
    {$IFNDEF DPMI}
      {$IFNDEF OS2}
        {$DEFINE BPLFN}
      {$ENDIF}
    {$ENDIF}
   {$ELSE}
      {$DEFINE Win16} 
   {$ENDIF}
{$ELSE}
  {$IFDEF VER80 }
    {$DEFINE BP}
    {$IFNDEF WINDOWS}
     {$IFNDEF DPMI}
       {$IFNDEF OS2}
         {$DEFINE BPLFN}
       {$ENDIF}
     {$ENDIF}
    {$ELSE}
      {$DEFINE Win16} 
    {$ENDIF}
  {$ELSE}
  { FreePascal }
  {$IFDEF Linux}
  {$IFDEF VER1_0}
    {$DEFINE unix1}
  {$ENDIF}
  {$ENDIF}
    {$IFDEF DPMI}
      {$UNDEF DPMI}
      {$DEFINE DOS32}
    {$ENDIF}
  {$ENDIF }
{$ENDIF }

{ Andere Compiler brauchen momentan keine Extras }
{
  $Log: touch.inc,v $
  Revision 1.17  2012-07-22 14:33:54  mw
  - Update auf Touch 1.4.1a

  Revision 1.16  2010/06/27 09:40:27  mw
  - Zu langer Checkin-Kommentar korrigiert

  Revision 1.15  2010/06/26 12:34:11  mw
  - Release 1.4.1

  Revision 1.14  2010/06/20 20:16:16  mw
  - Korrektes Define

  Revision 1.13  2010/06/20 15:35:58  mw
  - Sicherstellen das aus FreeXP heraus die Cryptolib (als Teil von Touch)
    fr Win64 nicht erstellt wird (funktioniert nicht, da FreePascal fr Win64
    kein Assembler kann).

  Revision 1.12  2010/06/20 15:33:50  mw
  - Sync mit Touch-Distrie

  Revision 1.11  2010/06/13 12:59:24  mw
  - Touch 1.4.1

  Revision 1.10  2008/12/26 18:37:14  mw
  - Aktualisierung auf Version 3.45

  Revision 1.9  2008-01-01 20:21:37  mw
  MW: - Wir haben jetzt 2008, und ich gebe Touch in den allgemeinen FreeXP-Pool

  Revision 1.8  2007-07-28 19:40:10  mw
  MW: - Update auf TOUCH 1.4.0

  Revision 1.7  2006/09/24 09:16:27  mw
  MW: - Update auf Touch 1.3.1

  Revision 1.6  2006/04/20 08:04:09  mw
  MW: - Update auf Touch 1.2.4

  Revision 1.5  2006/01/02 09:46:11  mw
  MW: - Update auf Touch 1.2.3

  Revision 1.4  2005/01/01 11:16:26  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.3  2004/11/28 11:45:38  mw
  MW: - Touch ist nun echte Freeware.

  Revision 1.2  2004/11/18 16:04:11  mw
  MW: - Update auf Touch 1.2

  Revision 1.1  2004/11/06 21:56:42  mw
  MW: - bernahme von TOUCH 1.1b:
        - Interne nderung, um NON-LFN-Versionen leichter zu realisieren.
}